<template>
    <Header :page="'Games'"></Header>
    <main>
        <section>
            <div class="search">
                <i class="pi pi-search" />
                <InputText class="w-full" ></InputText>
                <i v-if="searchResult" class="pi pi-spin pi-spinner" />
            </div>
            <div v-if="games && games.length">
                <Card v-for="game in games" :key="game" class="p-card w-full border-round-md max-h-30rem h-full">
                    <template #header class="h-15rem">
                        <div class="border-round-top-md" id="picture" :style="{ 'backgroundImage': `url(http://localhost:3000/files/${game.picture})`}"></div>
                    </template>
                    <template #title class="p-card-title">
                        {{game.name}}
                    </template>
                    <template #subtitle class="p-card-subtitle">
                        {{game.category}}
                    </template>
                    <!-- <template #content class="p-card-content">
                        <p>{{game.description}}</p>
                    </template> -->
                    <template #footer class="p-card-footer">
                        <Button icon="pi pi-play" class="p-button-success" label="JOUER" @click="goCreateOrJoin(game.id)" />
                        <Button icon="pi pi-question-circle" label="Détails" class="p-button-info" style="margin-left: .5em" />
                    </template>
                </Card>
            </div>
            <div v-if="!games || !games.length">
                <ProgressSpinner />
            </div>
        </section>
    </main>
</template>

<script>
import Header from "../components/Header.vue"
import InputText from 'primevue/inputtext';
import Card from 'primevue/card';
import ProgressSpinner from 'primevue/progressspinner';
import Button from 'primevue/button';

export default {
    name: "Profil",
    data() {
        return {
            games: [],
            searchResult: false
        }
    },
    components: {
        Header,
        InputText,
        Card,
        ProgressSpinner,
        Button
    },
    computed: {
        
    },
    methods: {
        getGames() {
            fetch(`http://localhost:3000/api/get-all-games`,
            {
                method: 'GET',
                headers: {
                'Content-Type': 'application/json',
                'Access-Control-Allow-Origin': '*'
                }
            })
            .then(r => r.json())
            .then(res => {
                this.games = res;
            })
        },
        goCreateOrJoin(game) {
            console.log(game);
            this.$router.push('/room/' + game);
        }
    },
    mounted() {
        this.getGames();
    }
}
</script>
<style scoped>
    main
    {
        width: 100%;
        min-height: 100vh;
        display: flex;
        justify-content: center;
        align-items: flex-start;
        background: rgb(0, 6, 24);
        background-size: cover;
    }
    section
    {
        width: 90%;
        min-height: 87vh;
        margin: 8rem 0 5rem 0;
        display: flex;
        flex-direction: column;
    }
    section > div:first-child {
        height: 45px;
        width: 20rem;
        max-width: 100%;
    }
    section > div:last-child {
        margin-top: 3rem;
        display: grid;
        grid-template-columns: 1fr;
        grid-gap: 30px;
    }
    #picture {
        height: 250px;
        background-position: center;
        background-size: cover;
    }
    .search {
        display: flex;
        background: #ffffff;
        justify-content: flex-start;
        align-items: center;
        padding: 0.5rem;
        gap: 0.5rem;
        border-radius: 0.375rem;
    }
    .pi-spin {
        margin-left: auto;
    }
    .search input{
        border: none !important;
    }
    @media screen and (min-width: 576px) {
        section > div:last-child {
        grid-template-columns: 1fr 1fr;
        }
    }
    @media screen and (min-width: 768px) {
        section > div:last-child {
        grid-template-columns: 1fr 1fr 1fr;
        }
    }
    @media screen and (min-width: 992px) {
        section > div:last-child {
        grid-template-columns: repeat(4, 1fr);
        }
    }
</style>